<?php
namespace Ep\Woo\Form\View\Helper;

use Ep\Form\View\Helper\AbstractFormHelper;
use Ep\Woo\Form\Element\Quantity as QuantityElement;

/**
 * Renderira polje za odabir količine.
 *
 * @package Ep\Woo\Form\View\Helper
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-woocommerce
 */
class Quantity extends AbstractFormHelper
{
    public function __invoke(QuantityElement $element)
    {
        if (!$element->getAttribute('id')) {
            $element->setAttribute('id', $this->generateId());
        }

        if (-1 === $element->getAttribute('max')) {
            $element->removeAttribute('max');
        }

        $vars = [
            'element' => $element,
            'label' => $element->getLabel(),
        ];

        if ($id = $element->getAttribute('id')) {
            $vars['id'] = $id;
        }

        $rendered = $this->getView()->render('@woo/form/element/quantity.html.twig', $vars);

        return apply_filters('ep_quantity_input', $rendered);
    }
}