<?php
namespace Ep\Woo\Plugin\Product;

use Ep\Cache\AbstractCacheFactory;
use Interop\Container\ContainerInterface;
use Zend\ServiceManager\Factory\FactoryInterface;
use Zend\View\Renderer\RendererInterface;

/**
 * Class ProductCarouselFactory
 *
 * @package Ep\Woo\Plugin\Product
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link http://gitlab.ep.local/ep-framework
 */
class ProductCarouselFactory implements FactoryInterface
{
    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     * @return object
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $renderer = $container->get(RendererInterface::class);
        $cache = $container->get('cache.shortcode');

        return new ProductCarousel($renderer, $cache);
    }
}