<?php
namespace Ep\Woo\View;

use Ep\Gath\Gath;

class BrandImage extends AbstractView
{
    protected $gath;

    public function __construct(Gath $gath = null)
    {
        $this->gath = $gath;
    }

    protected $templateOverrides = [
        'brand-image.php',
    ];

    /**
     * Renderira view.
     *
     * @return string
     */
    public function render(): string
    {
        /** @var $product \Ep\Woo\Product\Simple */
        global $product;

        $brand = $product->getBrand();

        if (!is_array($brand) || !isset($brand['image']) || empty($brand['image'])) {
            return '';
        }

        if (null !== $this->gath) {
            $image = rtrim($this->gath->getImageBaseUri(), '/') . '/images/' . ltrim($brand['image'], '/');
        }

        return $this->getRenderer()->render('@woo/brand-image.html.twig', [
            'image' => $image
        ]);
    }
}
