<?php
namespace EpTest\Woo\Plugin\Cart;

use Ep\Woo\Plugin\Cart\CartEvents;
use Ep\Woo\Test\AbstractWoocommerceTest;
use EpTest\ContainerAwareTrait;
use PHPUnit\Framework\MockObject\MockObject;
use WC_Cart;
use Zend\EventManager\EventManagerInterface;

final class CartEventsTest extends AbstractWoocommerceTest
{
    use ContainerAwareTrait;

    public function testAddEventIsTriggered()
    {
        $cart = \WC()->cart;
        $this->assertInstanceOf(WC_Cart::class, $cart);

        $container = $this->createContainer();
        /** @var EventManagerInterface $events */
        $events = $container->get('EventManager');

        $plugin = new CartEvents($events);
        $plugin->attach();

        /** @var Mock\CartEventListener|MockObject $listener */
        $listener = new Mock\CartEventListener();
        $listener->attach($events);

        do_action('woocommerce_add_to_cart', '1', '2', '3', '4', '5', '6');

        $this->assertSame($cart, $listener->target);
        $this->assertEquals([
            'cart_item_key' => '1',
            'product_id' => '2',
            'quantity' => '3',
            'variation_id' => '4',
            'variation' => '5',
            'cart_item_data' => '6',
        ], $listener->params);
    }
}