<?php
namespace EpTest\Woo\Plugin\Cart\Mock;

use Ep\Woo\Cart\CartEvent;
use WC_Cart;
use Zend\EventManager\EventManagerInterface;
use Zend\EventManager\ListenerAggregateInterface;
use Zend\EventManager\ListenerAggregateTrait;

final class CartEventListener implements ListenerAggregateInterface
{
    use ListenerAggregateTrait;

    /** @var WC_Cart */
    public $target;
    /** @var array */
    public $params;

    /**
     * Attach one or more listeners
     *
     * Implementors may add an optional $priority argument; the EventManager
     * implementation will pass this to the aggregate.
     *
     * @param EventManagerInterface $events
     * @param int $priority
     * @return void
     */
    public function attach(EventManagerInterface $events, $priority = 1)
    {
        $events->attach(CartEvent::EVENT_ADD, [$this, 'handler']);
    }

    public function handler(CartEvent $event)
    {
        $this->target = $event->getCart();
        $this->params = $event->getParams();
    }
}